#REM				Charge Controller
			Test Programme for PWM switching
				13th March 2008
#ENDREM



	#picaxe 28X					;commands Programming Editor to use its 28x1 settings


Start:
	;Caution(b0 & b1)	= w0			  tempory use 
	SYMBOL  BatAmp	= b2			; Battery Amps (metered)
	SYMBOL  Volt	= b3			; Battery Volts (metered)
	SYMBOL  boostV	= b4  		; Boost Voltage set-point
	SYMBOL  floatV	= b5	  		; Float Voltage set-point
	SYMBOL  availA	= b10			; Available Amps for charging	(metered)			
	SYMBOL  rangeV	= w3			; taper Voltage range 
	SYMBOL  duty	= w4			; PWM duty cycle
   	SYMBOL  loc		= b11			; temp use in Taper: & Float:
	SYMBOL  reset	= b12
prelim:
	boostV = 40
	floatV = 47
	duty = 0
	gosub Main
	high 1:pause 300			; Barp 	
	low 1:pause 2000
	goto prelim

Main:
	sertxd (".  D=",#duty,".  .  V=",#Volt,".  .  A=",#availA, cr,lf)
	
	dirsc = %00000010	 		; change pins from output for LED's to input for Menu buttons 
	if pin0 = 1 then OnOff
	if pin2 = 1 then Taper
	if pin3 = 1 then Float1 
	return


OnOff:		;switches Dump ON_6secs, then OFF_6secs, then 50%duty cycle_6secs, Bee Beep, then all over again
	pwmout 1 OFF			; turn OFF PWM pin output
	high 1:pause 50
	low 1:pause 50
	high 1:pause 50			; Bee Beep
	low 1
	high portc 1			; turn ON pin1
	low portc 4				; Boost Charge LED OFF
	low portc 2				; Taper Charge LED OFF
	low portc 3				; Float Charge LED OFF
	pause 6000
	high 1:pause 50			; Beep
	low 1
	low portc 1				; turn OFF pin1
	high portc 4			; Boost Charge LED ON
	low portc 2				; Taper Charge LED OFF
	low portc 3				; Float Charge LED OFF
	pause 6000
	high 1:pause 50			; Beep
	low 1
	let duty = 500
	pwmout 1, 249, duty		; turn ON PWM pin1 output @ 50% duty cycle
	high portc 2			; Boost Charge LED ON
	high portc 3			; Taper Charge LED ON
	high portc 4			; Float Charge LED ON
	pause 6000
	pwmout 1 OFF			; turn OFF PWM pin output	
	high portc 4			; Boost Charge LED ON
	low portc 2				; Taper Charge LED OFF
	low portc 3				; Float Charge LED OFF
	gosub Main
	goto OnOff



Taper:		;simulates a Tapering Duty Cycle with a changing Voltage and Available Amps (Terminal recording all data)
	high 1:pause 50
	low 1:pause 50
	high 1:pause 50			; Bee Beep
	low 1
	Volt = boostV			; set a start voltage
	availA = 100			; set a start availAmp
	reset = floatV + 1
	goto Taper1
Taper1:
  	FOR loc = 1 to 20			; start a 50 times loop (could be max 256)
	;readadc 2, availA		; read Available Amps signal
	;availA = availA-127 min 0
	let rangeV = floatV - boostV 
	let duty = Volt-boostV*availA*10/rangeV max 1000 min 0
	pwmout 1, 249, duty			; update duty cycle. 249 = 4kHz @ 4MHz
	;readadc10 0,w0				; read volts ADC signal
	;Volt = w0 - 100 min 0 max 255	; calculate Volts
	NEXT loc
	gosub Main
	high 1:pause 50				; Beep
	low 1
	low portc 4				; Boost Charge LED OFF
	high portc 2			; Taper Charge LED ON
	low portc 3				; Float Charge LED OFF
	pause 1000
	availA = availA - 13 min 0		; provide a changing available Amps here (if needed)
	Volt = Volt + 1				; provides an increasing voltage
	if Volt = reset then Taper
	goto Taper1




Float:		;simulates Float with Hi then Low Voltage (Terminal recording duty cycle as it corrects voltage drift)		

	FOR loc = 1 to 100			; start a 100 times loop (could be max 256), temp use of variable 'loc'
	if Volt > floatV then if duty < 1000 then inc duty: endif	; test for overflow and increment duty
	else
    	 if duty > 0 then dec duty: endif  	; test for underflow and decrement duty
	endif	
	pwmout 1, 249, duty			; update duty cycle. 249 = 4kHz @ 4MHz
	NEXT loc
	gosub Main
	high 1:pause 50				; Beep
	low 1
	low portc 4					; Boost Charge LED OFF
	low portc 2					; Taper Charge LED OFF
	high portc 3				; Float Charge LED ON
	pause 1000
	if duty = 1000 then Float2
	if duty = 0 then Float1
	goto Float
Float1:				; sets Voltage High
	Volt = 48
	high 1:pause 50		; Bee Beep
	low 1 :pause 50	
	high 1:pause 50
	low 1
	low portc 4					; Boost Charge LED OFF
	low portc 2					; Taper Charge LED OFF
	high portc 3				; Float Charge LED ON
	pause 1000
	goto Float
Float2:				; sets Voltage Low
	Volt = 46
	high 1:pause 100		; Bee Barp
	low 1 :pause 100
	high 1:pause 400
	low 1
	low portc 4					; Boost Charge LED OFF
	low portc 2					; Taper Charge LED OFF
	high portc 3				; Float Charge LED ON
	pause 1000
	goto Float



END





